summaryrefslogtreecommitdiffstats
path: root/lib
diff options
context:
space:
mode:
authorP. J. McDermott <pjm@nac.net>2012-01-30 16:04:30 (EST)
committer P. J. McDermott <pjm@nac.net>2012-01-30 16:04:30 (EST)
commitfa8794a5bf41b1a3ca3f7ed838226fd3e32ba503 (patch)
treee99f80ecfd09037f3b73b69f7e3aa5de731687be /lib
parentf9ac21c2b41d564fdc4a09becbc629e6de4f93e1 (diff)
Extract compressed source archives.
Diffstat (limited to 'lib')
-rw-r--r--lib/Makefile.in2
-rw-r--r--lib/archive72
2 files changed, 73 insertions, 1 deletions
diff --git a/lib/Makefile.in b/lib/Makefile.in
index 526bf3a..07c5b35 100644
--- a/lib/Makefile.in
+++ b/lib/Makefile.in
@@ -27,7 +27,7 @@ LIBDIR = @libdir@
.SUFFIXES:
-OBJS = controlfields architecture
+OBJS = controlfields architecture archive
.PHONY: all
all: $(OBJS)
diff --git a/lib/archive b/lib/archive
new file mode 100644
index 0000000..90cec3a
--- /dev/null
+++ b/lib/archive
@@ -0,0 +1,72 @@
+#! /bin/sh
+#
+# opkhelper
+# lib/archive
+# Functions for handling archive files.
+#
+# Copyright (C) 2012 Patrick "P. J." McDermott
+#
+# This program is free software: you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation, either version 3 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program. If not, see <http://www.gnu.org/licenses/>.
+
+oh_archive_extract_source()
+{
+ _matches="../${OH_SRCPKG}_${OH_PKGVER}.tar.*"
+
+ if [ "${_matches}" = ../${OH_SRCPKG}_${OH_PKGVER}.tar.\* ]; then
+ # No archive found.
+ return 1
+ fi
+
+ if [ -n "$(echo "${_matches}" | grep ' ')" ]; then
+ # Multiple archives found.
+ return 2
+ fi
+
+ # Detect the compression format.
+ # Note: dpkg's source format version 3 supports gzip, bzip2, LZMA, and XZ.
+ # We support gzip, bzip2, LZMA, and compress, since these are the formats
+ # supported by BusyBox tar.
+ z_ext=${_matches#"../${OH_SRCPKG}_${OH_PKGVER}.tar."}
+ case ${_z_ext} in
+ gz)
+ _z=z
+ ;;
+ bz2)
+ _z=j
+ ;;
+ lz)
+ _z=a
+ ;;
+ Z)
+ _z=Z
+ ;;
+ *)
+ return 3
+ ;;
+ esac
+
+ _files=$(tar -t${_z}f ../${OH_SRCPKG}_${OH_PKGVER}.tar.${_z_ext} | \
+ grep -v '^./$')
+
+ if [ -z "$(echo "${_files}" | grep '/$')" ]; then
+ return 4
+ fi
+ if [ "$(echo "${_files}" | grep '/$' | wc -l)" -ne 1 ]; then
+ return 5
+ fi
+
+ tar -x${_z}f ../${OH_SRCPKG}_${OH_PKGVER}.tar.${_z_ext} || return 6
+
+ mv "${_files}" src || return 7
+}